//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3AB1045301EA.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3AB1045301EA.cm

//## begin module%3AB1045301EA.cp preserve=no
//## end module%3AB1045301EA.cp

//## Module: DataUtility%3AB1045301EA; Package specification
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/DataUtility.h

#ifndef DATAUTILITY_H
#define DATAUTILITY_H 1

//## begin module%3AB1045301EA.additionalIncludes preserve=no
#include <XSModel/Data/Detector/RMF.h>
#include <CCfits/CCfits>
//## end module%3AB1045301EA.additionalIncludes

//## begin module%3AB1045301EA.includes preserve=yes
#include <xsTypes.h>
//## end module%3AB1045301EA.includes

// DataInputRecord
#include <XSModel/Data/DataInputRecord.h>
// DataFactory
#include <XSModel/DataFactory/DataFactory.h>
// OGIP-92aIO
#include <XSModel/DataFactory/OGIP-92aIO.h>
// Weight
#include <XSModel/GlobalContainer/Weight.h>

class SpectralData;
class DataSet;
class BackCorr;
class Response;

//## begin module%3AB1045301EA.declarations preserve=no
//## end module%3AB1045301EA.declarations

//## begin module%3AB1045301EA.additionalDeclarations preserve=yes
class RMF;

namespace CCfits
{
        class ExtHDU;       
}                

//## end module%3AB1045301EA.additionalDeclarations


//## begin DataUtility%3AB104CE022F.preface preserve=yes
//## end DataUtility%3AB104CE022F.preface

//## Class: DataUtility%3AB104CE022F; Class Utility
//## Category: XSModel::Data%36349D4100F3
//## Subsystem: XSModel::Data%367691B49E40
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3AC378A202C5;SpectralData { -> F}
//## Uses: <unnamed>%3AC378C702E5;Response { -> F}
//## Uses: <unnamed>%3AC3B1130383;friend OGIP_92aIO { -> }
//## Uses: <unnamed>%3AC3B22D01E6;DataSet { -> F}
//## Uses: <unnamed>%3AC3B27A03D3;BackCorr { -> F}
//## Uses: <unnamed>%3BB4BCF403BF;DataInputRecord { -> }
//## Uses: <unnamed>%3EC399C202B7;DataPrototype { -> }

class DataUtility 
{
  //## begin DataUtility%3AB104CE022F.initialDeclarations preserve=yes
  //## end DataUtility%3AB104CE022F.initialDeclarations

  public:
    //## begin DataUtility::recordList%3BB4B95302E1.preface preserve=yes
    //## end DataUtility::recordList%3BB4B95302E1.preface

    //## Class: recordList%3BB4B95302E1
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::list<DataInputRecord> recordList;

    //## begin DataUtility::recordList%3BB4B95302E1.postscript preserve=yes
    //## end DataUtility::recordList%3BB4B95302E1.postscript

    //## begin DataUtility::recordListIter%3BB4B9570324.preface preserve=yes
    //## end DataUtility::recordListIter%3BB4B9570324.preface

    //## Class: recordListIter%3BB4B9570324
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::list<DataInputRecord>::iterator recordListIter;

    //## begin DataUtility::recordListIter%3BB4B9570324.postscript preserve=yes
    //## end DataUtility::recordListIter%3BB4B9570324.postscript

    //## begin DataUtility::recordListConstIter%3BB4B95B03A7.preface preserve=yes
    //## end DataUtility::recordListConstIter%3BB4B95B03A7.preface

    //## Class: recordListConstIter%3BB4B95B03A7
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::list<DataInputRecord>::const_iterator recordListConstIter;

    //## begin DataUtility::recordListConstIter%3BB4B95B03A7.postscript preserve=yes
    //## end DataUtility::recordListConstIter%3BB4B95B03A7.postscript


    //## Other Operations (specified)
      //## Operation: readArrays%3AB104DB00A2
      static void readArrays (RMF& rmf, const CCfits::ExtHDU& fitsData);

      //## Operation: groupArrays%3AC11EC80301
      static void groupArrays (RMF& rmf, const size_t startChan, const size_t endChan);

      //## Operation: setSource%3AC374CF0337
      static void setSource (SpectralData* spectrum, Response* response, size_t sourceNum);

      //## Operation: encodeGQ%3ADB0BFC00E8
      static const CodeContainer& encodeGQ (const IntegerArray& group, const IntegerArray& quality, CodeContainer& coded);

      //## Operation: decodeGQ%3ADB0C2E0225
      static void decodeGQ (const CodeContainer& coded, IntegerArray& group, IntegerArray& quality);

      //## Operation: encode%3AE5F5D603C6
      static void encode (const IntegerArray& inputArray, CodeContainer& coded);

      //## Operation: decode%3AF0633101FC
      static void decode (const CodeContainer&  coded, IntegerArray& inputArray);

      //## Operation: fixSequence%3BB4B73F0183
      static void fixSequence (DataUtility::recordList& records, size_t spectraDefined);

      //## Operation: parseDataCommandString%3BB4B7550038
      //	Function to parse the input for a data command. This
      //	will be made general enough to serve for
      //	data,background,response and other data reading
      //	commands, although its full functionality is only
      //	required for   data.
      //
      //	Takes the Tcl_Obj array provided by the interpreter and
      //	determines:
      //
      //	An array (names) of data set names that correspond to
      //	filenames.
      //
      //	For each named file, the spectrum number (setNums) to be
      //	assigned to the first spectrum to be read from the file.
      //	The calling code will be responsible for (a) checking
      //	that this is a valid number and (b) incrementing the
      //	spectrum number assigned to following spectra read from
      //	the same file. The spectrum number assigned cannot be
      //	larger than one greater than previously assigned. That
      //	is, if there are  n datasets assigned or to be assigned,
      //	setNum <= n+1.
      //
      //	For each named file, the data group number to be
      //	assigned. Again, if the highest group number currently
      //	assigned is m, groupNum <= m+1.
      //
      //	For each named file, a range of spectra may be read from
      //	the file. The user must supply a range string in {}
      //	following the file name, as described under XSparse::get
      //	Ranges.
      static DataUtility::recordList parseDataCommandString (StringArray& args, XSutility::fileType defaultSuffix);

      //## Operation: dataToProcess%3BB4B7C00184
      static size_t dataToProcess (const recordList& records);

      //## Operation: statWeight%3E9C508203D9
      static const XSContainer::Weight& statWeight ();

      //## Operation: fixOverlap%3EAFDDA600B2
      static void fixOverlap (DataUtility::recordList& records);

      //## Operation: fixSpectrumGaps%3EB28F85031F
      static void fixSpectrumGaps (DataUtility::recordList& records, size_t spectraDefined);

      //## Operation: fixDataGroupsVsSpecNum%3EB29DDF01E1
      static void fixDataGroupsVsSpecNum (DataUtility::recordList& records);

      //## Operation: searchRecordListSpecNums%3EBA75A600D7
      static bool searchRecordListSpecNums (const recordList& records, const size_t specNum, recordListConstIter& currRec, size_t& index);

      //## Operation: prototypeFromResponse%3EC3989503C6
      static DataPrototype* prototypeFromResponse (string& responseName);

      //## Operation: getLostChannelNumbers%3F6F0C0E011C
      static void getLostChannelNumbers (const IntegerArray& quality, const IntegerArray& grouping, IntegerArray& lostChannels);

      //## Operation: patchGrouping%3FD64FC00176
      static void patchGrouping (const IntegerArray& quality, IntegerArray& grouping);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::GlobalContainer::Variance Scheme%3E9C51620384
      //## Role: DataUtility::weightScheme%3E9C51630193
      static void weightScheme (XSContainer::Weight* value);

  public:
    // Additional Public Declarations
      //## begin DataUtility%3AB104CE022F.public preserve=yes
      typedef struct bitcard 
      {
	 CodeField ntimes;
	 int flag;
      }  bitCard;
      
      template<class C, class T> 
      static void fillLostChannels(const IntegerArray& lostChans, 
                        const C& input, C& filled, T defVal);
      //## end DataUtility%3AB104CE022F.public
  protected:
    // Additional Protected Declarations
      //## begin DataUtility%3AB104CE022F.protected preserve=yes
      //## end DataUtility%3AB104CE022F.protected

  private:

    //## Other Operations (specified)
      //## Operation: makeInputRecords%3BB4B74E03DC
      static void makeInputRecords (size_t firstSpectrumNumber, size_t groupNumber, const string& inputString, recordList& inputRecordList, XSutility::fileType defaultSuffix);

    // Additional Private Declarations
      //## begin DataUtility%3AB104CE022F.private preserve=yes
      //## end DataUtility%3AB104CE022F.private

  private: //## implementation
    // Data Members for Associations

      //## Association: XSModel::GlobalContainer::Variance Scheme%3E9C51620384
      //## begin DataUtility::weightScheme%3E9C51630193.role preserve=no  public: XSContainer::Weight { -> 1RHgN}
      static XSContainer::Weight* s_weightScheme;
      //## end DataUtility::weightScheme%3E9C51630193.role

    // Additional Implementation Declarations
      //## begin DataUtility%3AB104CE022F.implementation preserve=yes
      //## end DataUtility%3AB104CE022F.implementation

};

//## begin DataUtility%3AB104CE022F.postscript preserve=yes
template <class C, class T>
void DataUtility::fillLostChannels(const IntegerArray& lostChans,
                const C& input, C& filled, T defVal)
{
   const size_t sz = lostChans.size();
   if (!sz)
   {
      filled = input;
      return;
   }
   size_t nLost = 0;
   for (size_t i=0; i<sz; ++i)
   {
      nLost += lostChans[i];
   }
   const size_t outSz = input.size() + nLost;
   filled.resize(outSz,0);
   T prevVal = (defVal >= static_cast<T>(0)) ? defVal : static_cast<T>(1);
   size_t idx = 0;
   for (size_t i=0; i<sz; ++i)
   {
      const size_t nInsert = lostChans[i];
      for (size_t j=0; j<nInsert; ++j)
      {
         filled[idx] = prevVal;
         ++idx;
      }
      if (i < sz-1)
      {
         filled[idx] = input[i];
         prevVal = (defVal >= static_cast<T>(0)) ? defVal : input[i];
         ++idx;
      }
   }
}
//## end DataUtility%3AB104CE022F.postscript

// Class Utility DataUtility 

//## begin module%3AB1045301EA.epilog preserve=yes
//## end module%3AB1045301EA.epilog


#endif
